jQuery(document).ready(function ($) {
    // Set correct states at startup
    $('select.vfasft-select').each(function () {
        hideAndShowOptions(this);
        updateWidgetTitle(this);
    });

    // Update states with every <select> change
    $('.widget-liquid-right').on('change', 'select.vfasft-select', function () {
        hideAndShowOptions(this);
        updateWidgetTitle(this);
    });
});

function hideAndShowOptions(element) {
    switch (element.value) {
        case 'vfasft-killcounter':
            jQuery(element).siblings('.subsidies-only').hide();
            jQuery(element).siblings('.killcounter-only').show();
            break;
        case 'vfasft-subsidies':
            jQuery(element).siblings('.killcounter-only').hide();
            jQuery(element).siblings('.subsidies-only').show();
            break;
        case 'vfasft-cta-button':
        case 'vfasft-cta-link':
            jQuery(element).siblings('.cta-custom-only').hide();
            break;
        case 'vfasft-cta-custom':
            jQuery(element).siblings('.cta-custom-only').show();
            break;
        default:
            break;
    }
}

function updateWidgetTitle(element) {
    let modeElement = jQuery(element).parent().children('select[id$="mode"]').children("option:selected");
    let mode = modeElement.text();
    let regionSelector;
    if(modeElement.hasClass("vfasft-option-killcounter")){
        regionSelector = "region_killcounter";
    }
    else if(modeElement.hasClass("vfasft-option-subsidies")){
        regionSelector = "region_subsidies";
    } 
    let region = jQuery(element).parent().children('select[id$="' + regionSelector + '"]').children("option:selected").text();
    let title = mode + ' (' + region + ')'; 
    jQuery(element).siblings('input[id$="title"]').val(title);

}
